
#ifndef PY_KRB5_KEYTAB_HPP
#define PY_KRB5_KEYTAB_HPP

#include <sys/types.h> // for int32_t
#include <boost/python.hpp>
#include "context.hpp"

struct _krb5_kt;
typedef struct _krb5_kt *krb5_keytab;

namespace py_kadm5
{
    class keytab : boost::noncopyable
    {
        public:
            keytab(boost::python::object error_callback,
                   const char* name);

            ~keytab();

            boost::python::list list();

            //next prototypes use (u)int32_t instead of
            //krb5_entctype and krb5_kvno, because I
            //don't want to incude krb5.h into this file
            //just for no reason - IM

            void add_entry(const char* princ,
                    uint32_t kvno, int32_t enctype,
                    boost::python::object key);

            int remove_princ(const char* princ,
                    uint32_t kvno, int32_t enctype);

        private:
            kcontext ctx_;
            krb5_context context()
            {
                return ctx_.context();
            }

            krb5_keytab kt_;
    };
}

#endif //PY_KRB5_KEYTAB_HPP
